
/*
      _______                          .__ .__   .__   .__                 
      \      \    ____   __ __ _______ |__||  |  |  |  |__|  ____    ____  
      /   |   \ _/ __ \ |  |  \\_  __ \|  ||  |  |  |  |  | /  _ \  /    \ 
     /    |    \\  ___/ |  |  / |  | \/|  ||  |__|  |__|  |(  <_> )|   |  \
     \____|__  / \___  >|____/  |__|   |__||____/|____/|__| \____/ |___|  /
    =========\/======\/=================================================\/==
  v0.01 07/SEP/2007   Copyright 2007-2007 Scott D. Yelich SOME RIGHTS RESERVED
  ,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.-*~'`^`'~*-,._.,-*~'`^`'~*-,


  LICENSE:  Creative Commons Attribution 3.0 License.
  SEE:      http://creativecommons.org/licenses/by/3.0/


  Fri Sep  7 19:20:26 EDT 2007, v0.01 sdy
  Fri Nov  9 23:00:32 EST 2007, v0.02 sdy
 
  This is Cache.cpp.  The idea is to make a very simple cache with strings
  used for both keys and values ( ie: std::map<std::string, std::string> );
  Really, then, this should be StringStringCache (StrStrCache?) ...

  TODO:
  (1)  append (w/ sep char?)
  (2)  list (of keys, iterator?)
  (3)  make cache generic and not just StrStrCache ...

*/

#include "Cache.h"

Cache::Cache()
{
}

Cache::~Cache()
{
}

bool
Cache::exists(std::string const & key)
{
  strstrMap::iterator iter;
  if ((iter = cache.find(key)) != cache.end()) {
    return true;
  }
  return false;
}

std::string
Cache::get(std::string const & key)
{
  std::string value;
  strstrMap::iterator iter;
  if ((iter = cache.find(key)) != cache.end()) {
    value = (*iter).second;
  }
  return value;
}

void
Cache::set(std::string const & key, std::string const & value)
{
  cache[key] = value;
}

void
Cache::erase(std::string const & key)
{
  strstrMap::iterator iter;
  if ( ( iter = cache.find(key)) != cache.end()) {
    cache.erase(iter);
  }
}

void
Cache::clear()
{
  cache.clear();
}

