
/*
      _______                          .__ .__   .__   .__                 
      \      \    ____   __ __ _______ |__||  |  |  |  |__|  ____    ____  
      /   |   \ _/ __ \ |  |  \\_  __ \|  ||  |  |  |  |  | /  _ \  /    \ 
     /    |    \\  ___/ |  |  / |  | \/|  ||  |__|  |__|  |(  <_> )|   |  \
     \____|__  / \___  >|____/  |__|   |__||____/|____/|__| \____/ |___|  /
    =========\/======\/=================================================\/==
  v0.01 09/NOV/2007   Copyright 2007-2007 Scott D. Yelich SOME RIGHTS RESERVED
  ,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.-*~'`^`'~*-,._.,-*~'`^`'~*-,


  LICENSE:  Creative Commons Attribution 3.0 License.
  SEE:      http://creativecommons.org/licenses/by/3.0/


  Fri Nov  9 23:00:32 EST 2007, v0.01 sdy
 
  This file is part of CommandLine.  Please see CommandLine.cpp for details.

*/

#ifndef COMMANDLINE_H
#define COMMANDLINE_H

//  C++

#include <sstream>
#include <iostream>

//  PACKAGE

#include "Cache.h"
#include "TypedException.h"

class CommandLine : public Cache
{
  public:

  CommandLine(bool strict_dashes = true, std::string const & prefix = "o_");
  ~CommandLine();

  enum Errors { InvalidParameter, RequiresParameter };

  int words(std::string const & opt);
  void process(int argc, char * argv[], std::string const & format = "");
  std::string program();

  int stringToInt(std::string const & s = "");
  std::string intToString(int i = 0);

  private:

  int argc;
  char ** argv;
  std::string progname;

  bool strict;

  std::string prefix;

};

#endif
